Subject: Re: [PATCH 2/3] spufs: fix another off-by-one bug in mbox_read

From: Arnd Bergmann <[email-masked]>
Date: Tue, 24 Oct 2006 21:58:32 +0200

On Tuesday 24 October 2006 21:53, Will Schmidt wrote:
> Hey Arnd,
>    just curiosity..   What was the behavior before this patch?   just
> leaving a few (0 - 3) characters behind?

It transfers more bytes than requested on a read. If you asked for
four bytes, you got eight.

Note: one nasty property of this file in spufs is that you can only
read multiples of four bytes in the first place, there is no way to
atomically put back a few bytes into the hardware register, so reading
less than four bytes returns -EINVAL. Asking for more than four
should return the largest possible multiple of four.

	Arnd <><